import { __rest } from "tslib";
import { toPascalCase, omit } from '../../vendors/toolbox';
import { getBehaviorByKey } from '../theme';
import { resolveWidgetCtor } from './base';
function resolveActionWidgetCtor(moduleContext, { action }) {
    return resolveWidgetCtor(moduleContext, action.widget, () => `${toPascalCase(action.renderType || getBehaviorByKey('common.action.renderType') || '')}ActionWidget`);
}
function resolveButtonProps({ primary, danger }, config, disabled) {
    const props = { disabled };
    if (config.size) {
        props.size = config.size;
    }
    if (primary) {
        props.color = 'primary';
    }
    if (danger) {
        props.color = 'danger';
    }
    return props;
}
function resolveIconProps({ icon }) {
    const props = {};
    if (icon) {
        props.refs = icon;
    }
    return props;
}
function resolveLinkProps(config) {
    return omit(config, ['showIcon', 'iconOnly', 'icon']);
}
function resolveControlPropsAndEvents(props, options) {
    const { className } = options, events = __rest(options, ["className"]);
    const resolved = Object.assign({}, props);
    if (className) {
        resolved.className = className;
    }
    return { props: resolved, events };
}
export { resolveActionWidgetCtor, resolveButtonProps, resolveIconProps, resolveLinkProps, resolveControlPropsAndEvents, };
