import type { IBaseComponent } from '@petals/basic';
import { FlexBreakpointListProp } from 'petals-ui/dist/basic';
import type { IFormComponent } from 'petals-ui/dist/form';
import { HistoryHelper, ComponentCtor, InputDescriptor, ClientAction, ListViewContext, createModuleContext } from '../../vendors/organik';
import type { ActionRenderType } from '../../types/render-type';
import type { ViewFieldDescriptor } from '../../types/input';
import type { DataTableProps } from '../../types/view';
import type { FormRendererProps, ViewRendererProps } from '../../types/renderer';
declare function renderFormChildren<DescriptorType extends InputDescriptor & {
    hidden?: boolean;
}, NodeType>(descriptors: DescriptorType[], arrangement: string | undefined, renderGroup: (title: string, formFieldNodes: NodeType[]) => NodeType, renderChild: (descriptor: DescriptorType) => NodeType, renderRow: (descriptors: DescriptorType[], cols: FlexBreakpointListProp[] | number) => NodeType): NodeType[];
declare function renderForm<NodeType>(props: FormRendererProps, renderGroup: (title: string, formFieldNodes: NodeType[]) => NodeType, renderChild: (descriptor: ViewFieldDescriptor) => NodeType, renderRow: (descriptors: ViewFieldDescriptor[], cols: FlexBreakpointListProp[] | number) => NodeType, render: (stuff: {
    FormControl?: ComponentCtor;
    props: Partial<IFormComponent & IBaseComponent>;
    children: NodeType[];
}) => NodeType): NodeType;
declare function resolveViewWidgetCtor<WidgetCtor extends ComponentCtor = ComponentCtor>(props: ViewRendererProps, componentAsserter: (ctor: any) => boolean, moduleContextCreator?: typeof createModuleContext): WidgetCtor | undefined;
declare function isConditionPersisted(viewContext: ListViewContext): boolean;
declare function persistsInUrl(history: HistoryHelper, params: Record<string, any>): void;
declare function restoreFromUrl(history: HistoryHelper): Record<string, any>;
declare function isActionsAuthorized(actionsAuthority: string | undefined, authority: Record<string, boolean> | null): boolean;
declare function resolveActionsAuthority(context: ListViewContext, vm: any): string | undefined;
declare function resolveAuthorizedActions(actions: ClientAction[], actionsAuthority: string | undefined, authority: Record<string, boolean> | null, vm: any): ClientAction[];
declare function resolveTopActions(context: ListViewContext, authority: Record<string, any> | null, vm: any): ClientAction[];
declare function resolveTableProps(context: ListViewContext, authority: Record<string, boolean> | null, vm: any, inlineButtonSize: string, inlineActionRenderType: ActionRenderType, cellRendererResolver: any, operationColumnResolver: any): DataTableProps;
export { renderFormChildren, renderForm, resolveViewWidgetCtor, isConditionPersisted, persistsInUrl, restoreFromUrl, isActionsAuthorized, resolveActionsAuthority, resolveAuthorizedActions, resolveTopActions, resolveTableProps, };
